﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using System.IO;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace WpfApplication25
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        string save = string.Empty;
        bool load = false;
        bool fielddeleted = false;
        ObservableCollection<Person> peeps = new ObservableCollection<Person>();

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            save = xamDataGrid1.SaveCustomizations();

            StreamWriter sw = new StreamWriter("Save.xml");
            sw.Write(save);
            sw.Close();
            fielddeleted = false;

        }
        private void loadCust()
        {

            StreamReader sr = new StreamReader("Save.xml");
            save = sr.ReadToEnd();
            load = true;
            // this code might be enough
            //xamDataGrid1.DataSource = null;
            //xamDataGrid1.FieldLayouts.Clear();
            //xamDataGrid1.DataSource = peeps;
            // 
            xamDataGrid1.LoadCustomizations(save);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            if (fielddeleted)
            {
                xamDataGrid1.DataSource = null;
                xamDataGrid1.FieldLayouts.Clear();
                xamDataGrid1.DataSource = peeps;
            }
            loadCust();
            fielddeleted = false;

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
          //  ObservableCollection<Person>  peeps = new ObservableCollection<Person>();
            Person p = new Person() { Name = "Matt", Address1 = "63 east cliff st", Married = false, DOB = new DateTime(1950, 10, 10), City = "somerville", ID = 1, Quantity = "0", State = "new Jersey", Zip = "112783-5344" };
            Person q = new Person() { Name = "Maryt", Address1 = "109 east cliff st", Married = true, DOB = new DateTime(1970, 12, 5), City = "somerville", ID = 2, Quantity = "5", State = "new Jersey", Zip = "112783-5344" };
            peeps.Add(p);
            peeps.Add(q);
            xamDataGrid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(xamDataGrid1_FieldLayoutInitialized);
            xamDataGrid1.FieldLayoutInitializing += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs>(xamDataGrid1_FieldLayoutInitializing);
            xamDataGrid1.DataSource = peeps;
            load = true;
        //    xamDataGrid1.FieldLayoutInitializing += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs>(xamDataGrid1_FieldLayoutInitializing);
        //    xamDataGrid1.FieldLayouts[0].PropertyChanged += new PropertyChangedEventHandler(MainWindow_PropertyChanged);
            xamDataGrid1.Loaded += new RoutedEventHandler(xamDataGrid1_Loaded);
            xamDataGrid1.Records.PropertyChanged += new PropertyChangedEventHandler(Records_PropertyChanged);
        
         
            
        }

        void Records_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            
        }

        void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
         
            xamDataGrid1.FieldLayouts[0].PropertyChanged += new PropertyChangedEventHandler(MainWindow_PropertyChanged);
        }

        void MainWindow_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
             
            if (load)
            {
                Dispatcher.BeginInvoke(new Action(() =>
                    {
                 //       MessageBox.Show(e.PropertyName);
                        
                    }), null);
               
            }
        }

        void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
           // throw new NotImplementedException();
          //  MessageBox.Show("fl ed");
        }

      

        void xamDataGrid1_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e)
        {
           // throw new NotImplementedException();
          //  MessageBox.Show("fl init ");
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.FieldLayouts[0].Fields.RemoveAt(0);
            fielddeleted = true;
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(xamDataGrid1.FieldLayouts.Count.ToString());
        }
    }
}
